function love.load()

	gr = love.graphics
	ph = love.physics	
	
	ph.setMeter(24)
	world = ph.newWorld( 0 * 64, 9 * 64, true )
	world:setCallbacks( beginContact, endContact, preSolve, postSolve )
	
	o = {}
	
	o.gD = {}
	o.gD.body = ph.newBody( world, 800/2, 600, "static" )
	o.gD.shape = ph.newRectangleShape( 800, 100 )
	o.gD.fixture = ph.newFixture( o.gD.body, o.gD.shape, 1 )
	o.gD.fixture:setUserData("Down")
	
	o.gU = {}
	o.gU.body = ph.newBody( world, 800/2, 0, "static" )
	o.gU.shape = ph.newRectangleShape( 800, 100 )
	o.gU.fixture = ph.newFixture( o.gU.body, o.gU.shape, 1 )
	o.gU.fixture:setUserData("Up")
	
	o.gL = {}
	o.gL.body = ph.newBody( world, 0, 600/2, "static" )
	o.gL.shape = ph.newRectangleShape( 100, 600 )
	o.gL.fixture = ph.newFixture( o.gL.body, o.gL.shape, 1 )
	o.gL.fixture:setUserData("Left")
	
	o.gR = {}
	o.gR.body = ph.newBody( world, 800, 600/2, "static" )
	o.gR.shape = ph.newRectangleShape( 100, 600 )
	o.gR.fixture = ph.newFixture( o.gR.body, o.gR.shape, 1 )
	o.gR.fixture:setUserData("Right")
	
	o.block = {}
	o.block.body = ph.newBody( world, 700, 400, "static" )
	o.block.shape = ph.newRectangleShape( 300, 50 )
	o.block.fixture = ph.newFixture( o.block.body, o.block.shape, 1 )
	o.block.fixture:setUserData("Block")
	
	o.block2 = {}
	o.block2.body = ph.newBody( world, 100, 250, "static" )
	o.block2.shape = ph.newRectangleShape( 300, 50 )
	o.block2.fixture = ph.newFixture( o.block2.body, o.block2.shape, 1 )
	o.block2.fixture:setUserData("Block2")
	
	o.ball = {}
	o.ball.body = ph.newBody( world, 200, 600/2, "dynamic" )
	o.ball.shape = ph.newRectangleShape( 32, 32 )
	o.ball.fixture = ph.newFixture( o.ball.body, o.ball.shape, 1 )
	o.ball.fixture:setUserData("Player")
	
	text = ""
end

function love.update(dt)
	dirLeftWE = love.joystick.getAxis( 1, 1 )
	dirLeftNS = love.joystick.getAxis( 1, 2 )
	
	worldTime = love.timer.getTime(dt)
	world:update(dt)
	
	if love.keyboard.isDown("lshift") then
		if love.keyboard.isDown("left") then
			o.ball.body:applyForce( -600, 0 )
		end
		if love.keyboard.isDown("right") then
			o.ball.body:applyForce( 600, 0 )
		end
	else
		if love.keyboard.isDown("left") then
			o.ball.body:applyForce( -400, 0 )
		end
		if love.keyboard.isDown("right") then
			o.ball.body:applyForce( 400, 0 )
		end
	end
	
	if jumpEnabled == true then
		if love.keyboard.isDown(" ") then
		o.ball.body:applyLinearImpulse( 0, -400 )
		end
	elseif jumpEnabled == false then
	
	end
	if love.joystick.isDown( 1, 3 ) then
		if dirLeftWE < -0.2 then
			o.ball.body:applyForce( -600, 0 )
		end
		if dirLeftWE > 0.2 then
			o.ball.body:applyForce( 600, 0 )
		end
	else
		if dirLeftWE < -0.2 then
			o.ball.body:applyForce( -400, 0 )
		end
		if dirLeftWE > 0.2 then
			o.ball.body:applyForce( 400, 0 )
		end
		if dirLeftWE < -0.2 and dirLeftWE > 0.2 then
			o.ball.body:applyForce( 0, 0 )
		end
	end
	if jumpEnabled == true then
		if love.joystick.isDown( 1, 1 ) then
			o.ball.body:applyLinearImpulse( 0, -400 )
		end
	elseif jumpEnabled == false then
	
	end
end

function love.draw()
	gr.setColor( 255, 255, 255 )
	gr.polygon( "fill", o.gD.body:getWorldPoints(o.gD.shape:getPoints()))
	
	gr.setColor( 255, 255, 255 )
	gr.polygon( "fill", o.gU.body:getWorldPoints(o.gU.shape:getPoints()))
	
	gr.setColor( 255, 255, 255 )
	gr.polygon( "fill", o.gL.body:getWorldPoints(o.gL.shape:getPoints()))
	
	gr.setColor( 255, 255, 255 )
	gr.polygon( "fill", o.gR.body:getWorldPoints(o.gR.shape:getPoints()))
	
	gr.setColor( 255, 255, 255 )
	gr.polygon( "fill", o.block.body:getWorldPoints(o.block.shape:getPoints()))
	
	gr.setColor( 255, 255, 255 )
	gr.polygon( "fill", o.block2.body:getWorldPoints(o.block2.shape:getPoints()))
	
	gr.setColor( 255, 0, 0 )
	gr.polygon( "fill", o.ball.body:getWorldPoints(o.ball.shape:getPoints()))
	
	gr.setColor( 0, 0, 0 )
	gr.print( worldTime, 5, 600-15, 0, 1, 1, 0, 0 )
	gr.print( text, 5, 600-45, 0, 1, 1, 0, 0 )
	
	gr.print( o.ball.body:getX() .. ", " .. o.ball.body:getY(), 5, 600-30, 0, 1, 1, 0, 0 )
end


function beginContact(a, b, coll)
	local x, y = coll:getNormal()
	text = a:getUserData() .. " is touching " .. b:getUserData() .. " at " .. x .. ", " .. y
	
	if a:getUserData() == "Down"
	or a:getUserData() == "Right"
	or a:getUserData() == "Block"
	or a:getUserData() == "Block2"	then

		jumpEnabled = true
	end
end

function endContact(a, b, coll)
	text = ""
	jumpEnabled = false
end

function preSolve(a, b, coll)

end

function postSolve(a, b, coll)

end
